# --- Coded using Arty-fishL Super Scripter Addon ---

from threading import Thread
from time import sleep
global edus, frame_sizeX, frame_sizeY, frame_locationX, frame_locationY, cursorCaptured, cursorTracked, cursorLastX, cursorLastY
edus = edu.cmu.cs.stage3

def everything():
	# reset rogue varibles
	resetVars()
	# get window location and size
	sizex, sizey = getWS()
	global frame_sizeX, frame_sizeY, frame_locationX, frame_locationY
	frame_sizeX, frame_sizeY = getFrameSize()
	frame_locationX, frame_locationY = getFrameLocation()
	# location values must be preset before launching this code
	locx = int(world.win_locationX)
	locy = int(world.win_locationY)
	# disable window buttons in frame
	disableWindowButtons()
	# decorate frame
	##decorateFrame() # does nothing anymore
	# set cursor hidden in frame
	setCursorVisibility(false)
	# centre cursor
	centreCursor()
	setCursorCaptured(true)
	# add listeners to play frame
	jf = getPlayFrame()
	jf.addComponentListener( winChanged() )
	jf.addWindowFocusListener( frameFocusListener() )
	# continue to track
	global cursorCaptured, cursorTracked, cursorLastX, cursorLastY
	cursorCaptured, cursorTracked = true, true
	cursorLoc = java.awt.MouseInfo.getPointerInfo().getLocation()
	cursorLastX, cursorLastY = cursorLoc.getX(), cursorLoc.getY()
	class basicThread(Thread):
		def run(self):
			# tracking and capturing the cursor
			global cursorTracked
			curTrk = true
			while(curTrk == true):
				try:
					global cursorLastX, cursorLastY
					try:
						cursorLastX += 0
						cursorLastY += 0
					except:
						cursorLastX = 0
						cursorLastY = 0
					# get cursor location
					try:
						cursorLoc = java.awt.MouseInfo.getPointerInfo().getLocation()
						cursorX, cursorY = cursorLoc.getX(), cursorLoc.getY()
						world.cursorX, world.cursorY = float(cursorX), float(cursorY)
					except:
						cursorX, cursorY = int(cursorLastX), int(cursorLastY)
						world.cursorX, world.cursorY = float(cursorLastX), float(cursorLastY)
					# work out cursor change value
					world.offsetX = float(cursorX - cursorLastX)
					world.offsetY = float(cursorY - cursorLastY)
					world.aimX += world.offsetX
					world.aimY += world.offsetY
					if(cursorCaptured):
						centreCursor()
					# set cursor last location info
					try:
						cursorLoc = java.awt.MouseInfo.getPointerInfo().getLocation()
						cursorLastX, cursorLastY = cursorLoc.getX(), cursorLoc.getY()
					except:
						cursorLastX, cursorLastY = int(cursorX), int(cursorY)
				except:
					# FFS
					pass
				# wait a little
				try:
					sleep(world.pulse)
				except:
					pass
				# use except for while cos threads are fucked up
				try:
					curTrk = int(cursorTracked)
				except:
					curTrk = true
	basicThread().start()

def getWS():
	# get render panel size as representative window size
	rect = world.renderTarget.getActualViewport(camera)
	if(rect.getWidth()<=rect.getHeight()):
		world.restore()
		world.start()
	world.win_sizeX = rect.getWidth()
	world.win_sizeY = rect.getHeight()
	return(world.win_sizeX, world.win_sizeY)

def getFrameSize():
	# get actual play window frame size
	frame = getPlayFrame()
	rect = frame.getSize()
	wsizeX = rect.getWidth()
	wsizeY = rect.getHeight()
	return(wsizeX, wsizeY)

def getFrameLocation():
	# get actual play window location
	frame = getPlayFrame()
	rect = frame.getLocation()
	wlocX = rect.getX()
	wlocY = rect.getY()
	return(wlocX, wlocY)
	
def setCursorVisibility(visible):
	# change visibility of cursor in render component of play window
	renderwin = world.renderTarget.getAWTComponent().getParent().getParent().getParent()
	if(visible == false):
		# hide cursor
		cursorImg = java.awt.image.BufferedImage(16, 16, java.awt.image.BufferedImage.TYPE_INT_ARGB)
		blankCursor = java.awt.Toolkit.getDefaultToolkit().createCustomCursor(cursorImg, java.awt.Point(0, 0), "blank cursor")
		renderwin.setCursor(blankCursor)
	else:
		# reset cursor to default
		renderwin.setCursor(None)
	renderwin.repaint()

def setCursorCaptured(captureit):
	# set whether or not to centre the cursor constantly
	global cursorCaptured
	cursorCaptured = int(captureit)
	
def stopTrackingIfClosed():
	# detect if play window is closed and if so, stop tracking cursor
	class basicThread(Thread):
		def run(self):
			sleep(2)
			if(world.isRunning() == false):
				# frame definately closed
				global cursorTracked
				cursorTracked = false
				# reset rogue variables
				resetVars()
	basicThread().start()

def centreCursor():
	# centre the cursor in the play render frame
	# location and size values must be preset before launching this code
	try:
		wsizex = int(world.win_sizeX)
		wsizey = int(world.win_sizeY)
		wlocx = int(world.win_locationX)
		wlocy = int(world.win_locationY)
		# get location for cursor
		locx = int(wlocx + (wsizex / 2) )
		locy = int(wlocy + (wsizey / 2) )
		# move cursor
		edus.awt.AWTUtilities.setCursorLocation(locx, locy)
	except:
		pass
	
def getPlayFrame():
	# return the play window frame component
	frame = world.renderTarget.getAWTComponent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent()
	return(frame)
	
def disableWindowButtons():
	comps = world.renderTarget.getAWTComponent().getParent().getParent().getParent().getParent().getParent().getComponents()[0].getComponents()
	# enable wanted buttons
	wants = [
	"Pause the running of the world (Pause/Break)",
	"Resume the running of the world (Page Up)",
	"Restart the world (Backspace)",
	"Stop the running of the world (Esc)",
	"Take a screenshot of the current scene (Ctrl-G)",
	]
	if(world.enableSpeedBar == true):
		pass
	if(world.enableRestartButton == false):
		del wants[2]
	for c in comps:
		if((c.getAccessibleContext().getAccessibleDescription() in wants) == false):
			try:
				c.setEnabled(false)
				c.repaint()
			except:
				None
	world.renderTarget.getAWTComponent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().repaint()

def enableWindowButtons():
	comps = world.renderTarget.getAWTComponent().getParent().getParent().getParent().getParent().getParent().getComponents()[0].getComponents()
	# enable all buttons
	for c in comps:
		try:
			c.setEnabled(true)
			c.repaint()
		except:
			None
	world.renderTarget.getAWTComponent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().repaint()

class winChanged(java.awt.event.ComponentListener):
	def componentMoved(self, event):
		if(world.enableWindowMove == false):
			frame = getPlayFrame()
			frame.setLocation( int(frame_locationX), int(frame_locationY))
	def componentHidden(self, event):
		None
	def componentShown(self, event):
		None
	def componentResized(self, event):
		if(world.enableWindowResize == false):
			frame = getPlayFrame()
			frame.setSize( java.awt.Dimension( int(frame_sizeX), int(frame_sizeY) ) )

class frameFocusListener( java.awt.event.WindowFocusListener ):	
	def windowGainedFocus(self, e):
		# frame in focus
		frame = getPlayFrame()
		# try to return window from transluceny
		try:
			import com
			com.sun.awt.AWTUtilities.setWindowOpacity(frame, 1.0)
		except:
			pass
		frame.invalidate()
		frame.validate()
		frame.repaint()
		# disable window buttons
		disableWindowButtons()
		# recapture and hide mouse
		setCursorVisibility(false)
		setCursorCaptured(true)
	
	def windowLostFocus(self, e):
		# frame not in focus
		frame = getPlayFrame()
		# try to make window translucent
		try:
			import com
			com.sun.awt.AWTUtilities.setWindowOpacity(frame, 0.3)
		except:
			pass
		frame.invalidate()
		frame.validate()
		frame.repaint()
		# stop capturing mouse and show it
		setCursorVisibility(true)
		setCursorCaptured(false)
		# reenable window buttons
		enableWindowButtons()
		# check if window is closed
		stopTrackingIfClosed()
		
def decorateFrame():
	# make the frame pretty
	# not much here yet
	frame = getPlayFrame()
	#frame.setUndecorated(true)
	#frame.setResizable(false) # modifies the frame and causes issues

def resizeWin(x,y):
	# resize the frame relative to the render panel (win)
	# get win vs frame offset
	global frame_sizeX, frame_sizeY
	difx = frame_sizeX - world.win_sizeX
	dify = frame_sizeY - world.win_sizeY
	sizex = x + difx
	sizey = y + dify
	frame_sizeX = int(sizex)
	frame_sizeY = int(sizey)
	frame = getPlayFrame()
	isResizable = frame.isResizable()
	frame.setResizable(false)
	frame.setSize( java.awt.Dimension( int(sizex), int(sizey) ) )
	frame.setResizable(isResizable)

def closeWindow():
	renderPanel = world.renderTarget.getAWTComponent()
	#world.renderTarget.getAWTComponent().getParent().getParent().getParent().add(renderPanel)
	renderPanel.hide()
	frame.hide()
	frame.dispose()
	#world.renderTarget.getAWTComponent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent().repaint()
	world.stop()

def resetVars():
	# reset rogue variables
	world.win_sizeX = 1.0
	world.win_sizeY = 1.0
	#world.win_locationX = 1.0
	#world.win_locationY = 1.0
	world.cursorX = 1.0
	world.cursorY = 1.0
	world.aimX = 1.0
	world.aimY = 1.0
	world.offsetX = 1.0
	world.offsetY = 1.0

def calcMoveX(lastX):
	# calculate turning variable
	try:
		changeX = world.aimX - lastX
		world.moveX = changeX / ( (101 - world.sensitivity ) * 75)
	except:
		world.moveX = 0.0

def calcMoveY(lastY):
	# calculate turning variable
	try:
		changeY = world.aimY - lastY
		world.moveY = changeY / ( (101 - world.sensitivity ) * 75)
	except:
		world.moveY = 0.0